package com.zksy.web.controller.basicData;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmAbnormalBusinessList;
import com.zksy.system.basicData.service.CrmAbnormalBusinessListService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 经营异常名录Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmAbnormalBusinessList")
@Api(tags = "经营异常名录", description = "经营异常名录desc")
public class CrmAbnormalBusinessListController extends BaseController {

    @Autowired
    private CrmAbnormalBusinessListService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "经营异常名录搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "经营异常名录分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "经营异常名录查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增经营异常名录
     */
    @PostMapping("/save")
    @ApiOperation(value = "经营异常名录新增")
    @Log(title = "新增经营异常名录", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmAbnormalBusinessList crmAbnormalBusinessList) {
        return service.save(crmAbnormalBusinessList);
    }

    /**
     * 修改经营异常名录
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "经营异常名录修改")
    @Log(title = "修改经营异常名录", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmAbnormalBusinessList crmAbnormalBusinessList) {
        return service.updateById(crmAbnormalBusinessList);
    }

    /**
     * 导入经营异常名录
     */
    @ApiOperation("经营异常名录导入")
    @Log(title = "经营异常名录", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmAbnormalBusinessList> crmAbnormalBusinessListAll = service.list();
            List<CrmAbnormalBusinessList> list = ExcelUtils.readMultipartFile(file, CrmAbnormalBusinessList.class,CrmAbnormalBusinessList.class.getDeclaredFields().length - 2);
            if(crmAbnormalBusinessListAll != null && crmAbnormalBusinessListAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }

            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("经营异常名录导出")
    @Log(title = "经营异常名录", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmAbnormalBusinessList> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"经营异常名录",wrapperList,CrmAbnormalBusinessList.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "经营异常名录", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除经营异常名录", notes = "删除经营异常名录")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }
    
    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"经营异常名录模板");
    }
}

